package com.javainuse.boot_keyvault.controller;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

import com.azure.core.credential.TokenCredential;
import com.azure.identity.DefaultAzureCredentialBuilder;
import com.azure.identity.ManagedIdentityCredentialBuilder;
import com.azure.security.keyvault.secrets.SecretClient;
import com.azure.security.keyvault.secrets.SecretClientBuilder;
import com.azure.security.keyvault.secrets.models.KeyVaultSecret;

@RestController
public class AzureController {

	@GetMapping("/getsecret")
	public String hello() {
		String keyVaultUrl = "https://javainuse-keyvault.vault.azure.net/";
		String secretName = "new-secret";
		String fetchedSecret = null;

		try {
			
			TokenCredential tokenCredential = new ManagedIdentityCredentialBuilder().clientId("d266f307-b9ff-4483-b62d-a8c178ffa5f6").build();
			// Create a SecretClient instance to interact with Azure Key Vault
			SecretClient secretClient = new SecretClientBuilder().vaultUrl(keyVaultUrl)
					.credential(tokenCredential).buildClient();

			// Retrieve the Base64-encoded secret from Azure Key Vault
			KeyVaultSecret secret = secretClient.getSecret(secretName);
			fetchedSecret = "Fetched Secret Values is " + secret.getValue();

			System.out.println("Truststore created successfully at: " + fetchedSecret);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return fetchedSecret;
	}

}